<template>
  <div :id="id">
    <template
    class="gps-location"  v-if="field.displayType == Constant.PermissionType_HIDDEN || field.textType == 'hidden'"
    >
      <!--隐藏-->
      <input type="hidden" v-model="field.value" />
      <!-- <span style="width:100%;padding-left:10px;">{{field.hiddenValue}}</span> -->
      <div class="mint-cell mint-field" v-if="field.mobile&&field.hiddenValue">
        <div class="mint-wrapper">
          <div class="mint-title">
            <span class="mint-text">{{field.discript?field.discript:field.name}}</span>
          </div>
           <div class="mint-value">
              <span class="mint-text">{{field.hiddenValue}}</span>
          </div>
        </div>
      </div>
    </template>

    <template
      class="gps-location"
      v-else-if="field.textType == 'readonly' || field.displayType == Constant.PermissionType_READONLY || field.displayType == Constant.PermissionType_DISABLED"
    >
      <!-- <template v-if="field.readOnlyShowValOnly">
      </template>

      <template v-else></template> -->
      <div class="mint-wrapper">
        <div class="mint-title">
          <span class="mint-text">{{field.discript ? field.discript : field.name}}</span>
        </div>
        <div class="mint-value">
          <span class="mint-text">{{field.position ? field.position.address : ''}}</span>
        </div>
      </div>
    </template>

    <template class="gps-location" v-else-if="field.displayType == Constant.PermissionType_MODIFY">
      <baidu-map
        :center="center" 
        :zoom="zoom" 
        @ready="handler" 
      >
      </baidu-map>
      <!--可编辑-->
      <div class="mint-cell mint-field" v-if="field.mobile">
        <div class="mint-wrapper">
          <div class="mint-title">
            <span class="mint-text">{{field.discript ? field.discript : field.name}}</span>
          </div>
          <div class="mint-value">
            <span class="mint-text">{{field.position ? field.position.address : ''}}</span>
          </div>
        </div>
        <div class="mint-cell-img" @click="getCurrentPosition(field.value)">
          <img src="../assets/images/gps.png" width="16" height="16" />
        </div>
      </div>
    </template>
  </div>
</template>

<script>
import wx from "weixin-js-sdk";
import Constant from "@/Constant.js";
export default {
  name: "o-gps",
  props: ["id"],
  computed: {
    field: function() {
      let formData = this.$parent.findField(this.id);
      formData.position=formData.value;
      if(formData.position) {
        formData.position = JSON.parse(formData.position)
      }
      return this.$parent.findField(this.id);
    }
  },
  mounted() {
    window['onClickGetGps'] = (res)=> {
      this.onClickGetGps(res)
    }
    let value = this.field.value
    if(!value) {
      this.getCurrentPosition()
    }
  },

  data: function() {
    return {
      Constant,
      currentPosition:'',
      center: {
        lng: 113.261503, 
        lat: 23.131377
      },
      zoom: 9,
      isShow:false,
      currentP: ''
    };
  },

  methods: {
    handler ({BMap}) {
      //以下不要删除先
      // let field = this.field
      // let ua = window.navigator.userAgent;
      // if(!field.value && ua.indexOf("myApps") == -1 && (ua.toLowerCase().indexOf("wxwork") == -1 && ua.toLowerCase().indexOf("weixin") == -1)) {
      //   let that = this;	// 设置一个临时变量指向vue实例，因为在百度地图回调里使用this，指向的不是vue实例；
      //   let geolocation = new BMap.Geolocation();
      //   geolocation.getCurrentPosition(function(res){
      //     let lat = res.latitude;
      //     let lng = res.longitude;
      //     // wgs84转百度坐标系
      //     let ssws=that.wgs84togcj02(lng, lat);
      //     ssws = that.gcj02tobd09(ssws[0]  , ssws[1] );
      //     //解决定位偏移
      //     let newLat = ssws[1] - 0.000160;
      //     let newLng = ssws[0] - 0.000160;
      //     let bdPoint = new BMap.Point(newLng.toFixed(6), newLat.toFixed(6));
      //     let geoc = new BMap.Geocoder();
      //     //坐标逆解析为地址
      //     geoc.getLocation(bdPoint, (rs) => {
      //       that.field.position = {
      //         latitude: newLat.toFixed(6),
      //         longitude: newLng.toFixed(6),
      //         address: rs.address,
      //       }
      //       let data = JSON.stringify(that.field.position);
      //       that.field.value = data;
      //     });
      //   })
      // }
    },
    
    onClickGetGps(res){
      let currentfieldId = localStorage.getItem("currentGpsFieldId");
      let list = this.$parent.getAllFields();
      let datas = JSON.parse(res);
      let latitude = datas.latitude; // 纬度，浮点数，范围为 90 ~ -90
      let longitude = datas.longitude; // 经度，浮点数，范围为 180 ~ -180。
      let bdPoint = new BMap.Point(longitude,latitude);
      let geoc = new BMap.Geocoder();
      for(let i=0; i<list.length; i++) {
        if(currentfieldId == list[i].id) {
          geoc.getLocation(bdPoint, function(rs){
              let addComp = rs.addressComponents;
              let locationName = addComp.province+ addComp.city + addComp.district + addComp.street + addComp.streetNumber;
              list[i].position = {
                latitude: latitude,
                longitude: longitude,
                address: locationName,
              }
              let data = JSON.stringify(list[i].position);
              list[i].value = data;
          });
          break;
        }
      }
      //坐标逆解析为地址
      
    },

    getCurrentPosition() {
      localStorage.setItem('currentGpsFieldId',this.field.id);
      let ua = window.navigator.userAgent;
      let that = this;
      if(ua.indexOf("myApps") >= 0) { //嗨办公
        this.getLocal({
          type: 'wgs84',
          result: (res) => {
            onClickGetGps(res);
          }
        });
      }else if (ua.toLowerCase().indexOf("wxwork") >= 0 || ua.toLowerCase().indexOf("weixin") >= 0){ 
        let _url = location.href.split("#")[0];
        this.$api.getWeixinApi(
          encodeURIComponent(_url),
          {  
            onSucess: response => {
              let that = this;
              wx.config({
                debug: false, // 开启调试模式,调用的所有api的返回值会在客户端alert出来，若要查看传入的参数，可以在pc端打开，参数信息会通过log打出，仅在pc端时才会打印。
                appId: response.data.data.appId, // 必填，公众号的唯一标识
                timestamp: response.data.data.timestamp, // 必填，生成签名的时间戳
                nonceStr: response.data.data.nonceStr, // 必填，生成签名的随机串
                signature: response.data.data.signature, // 必填，签名，见附录1
                jsApiList: [
                  "checkJsApi",
                  "getLocation",
                ] // 必填，需要使用的JS接口列表，所有JS接口列表见附录2
              });
            
              wx.getLocation({
                  success: function (res) {
                    that.currentPosition = res;
                    let lat = res.latitude;
                    let lng = res.longitude;
                    // wgs84转百度坐标系
                    let ssws=that.wgs84togcj02(lng, lat);
                    ssws = that.gcj02tobd09(ssws[0]  , ssws[1] );
                    //解决定位偏移
                    let newLat = ssws[1] - 0.000160;
                    let newLng = ssws[0] - 0.000160;
                    let bdPoint = new BMap.Point(newLng.toFixed(6), newLat.toFixed(6));

                    // let bdPoint = new BMap.Point(res.longitude, res.latitude);
                    let geoc = new BMap.Geocoder();
                    //坐标逆解析为地址
                    geoc.getLocation(bdPoint, (rs) => {
                      that.field.position = {
                        latitude: newLat.toFixed(6),
                        longitude: newLng.toFixed(6),
                        address: rs.address,
                      }
                      let data = JSON.stringify(that.field.position);
                      that.field.value = data;
                    });
                  },
                  cancel: function () {
                    alert('用户拒绝授权获取地理位置');
                  }
              });
            }
          }
        );
      }else {
        // let _this = this
        // var geolocation = new BMap.Geolocation();
        // geolocation.getCurrentPosition(function(r) {
        //   if (this.getStatus() == BMAP_STATUS_SUCCESS) {
        //     if(r.accuracy==null){
        //       alert('您已拒绝地理位置授权');
        //       //用户决绝地理位置授权
        //       return;
        //     }else{
        //       const myGeo = new BMap.Geocoder()
        //       myGeo.getLocation(new BMap.Point(r.point.lng, r.point.lat), data => {
        //        alert('33');
        //       })
        //     }
        //   }
        // })
         
        // if (navigator.geolocation) {
        //     let options = {
        //         enableHighAccuracy: true,
        //         timeout: 5000,
        //         maximumAge: 1000
        //     }
        //     navigator.geolocation.getCurrentPosition(onSuccess,onError,options);
        //     function onSuccess(position) {
        //         alert("keyi")
        //         //经度
        //         longitude = position.coords.longitude;

        //         //纬度
        //         latitude = position.coords.latitude;
        //     }

        //     function onError(error) {
        //       switch (error.code) {
        //           case 1:
        //               alert("位置服务被拒绝");
        //               break;

        //           case 2:
        //               alert("暂时获取不到位置信息");
        //               break;

        //           case 3:
        //               alert("获取信息超时");
        //               break;

        //           case 4:
        //               alert("未知错误");
        //               break;
        //       }
        //     }
        // } else {
        //   alert('Geolocation is not supported by this browser.')
        // }
      }
    },

    getLocal(callback) {
      let that = this;
      let u = navigator.userAgent;
      let isiOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/);
      let isAndroid = u.indexOf('Android') > -1 || u.indexOf('Adr') > -1; //android终端
      if(isiOS){
        let result = callback.result;
        callback.result = result.toString();
        window.webkit.messageHandlers.getLocation.postMessage(callback);
      }else if(isAndroid){
        let _native = top.nativeAPI ? top.nativeAPI : nativeAPI;
        _native.getLocation({
          type: 'wgs84', // 默认为 wgs84 的 gps 坐标
          success: function (res) {
            let datas = JSON.parse(res);
            let latitude = datas.latitude; // 纬度，浮点数，范围为 90 ~ -90
            let longitude = datas.longitude; // 经度，浮点数，范围为 180 ~ -180。
            let bdPoint = new BMap.Point(longitude,latitude);
            let geoc = new BMap.Geocoder();
            //坐标逆解析为地址
            geoc.getLocation(bdPoint, function(rs){
                let addComp = rs.addressComponents;
                let locationName = addComp.province+ addComp.city + addComp.district + addComp.street + addComp.streetNumber;
                that.field.position = {
                  latitude: latitude,
                  longitude: longitude,
                  address: locationName,
                }
                let data = JSON.stringify(that.field.position);
                that.field.value = data;
            });
          }
        });
      }
    },

    //地图定位精确方法
    /**
     * WGS84转GCj02
     * @param lng
     * @param lat
     * @returns {*[]}
    */
    wgs84togcj02(lng, lat) {
      let that=this
      // let x_PI = 3.14159265358979324 * 3000.0 / 180.0;
      let PI = 3.1415926535897932384626;
      let a = 6378245.0;
      let ee = 0.00669342162296594323;
      if (that.out_of_china(lng, lat)) {
        return [lng, lat]
      }else {
        let dlat = that.transformlat(lng - 105.0, lat - 35.0);
        let dlng = that.transformlng(lng - 105.0, lat - 35.0);
        let radlat = lat / 180.0 * PI;
        let magic = Math.sin(radlat);
        magic = 1 - ee * magic * magic;
        let sqrtmagic = Math.sqrt(magic);
        dlat = (dlat * 180.0) / ((a * (1 - ee)) / (magic * sqrtmagic) * PI);
        dlng = (dlng * 180.0) / (a / sqrtmagic * Math.cos(radlat) * PI);
        let mglat = Number(lat) + Number(dlat);
        let mglng = Number(lng) + Number(dlng);
        return [mglng, mglat]
      }
    },
    /**
     * 火星坐标系 (GCJ-02) 与百度坐标系 (BD-09) 的转换
     * 即谷歌、高德 转 百度
     * @param lng
     * @param lat
     * @returns {*[]}
     */
    gcj02tobd09(lng, lat) {
      // let that = this
      let x_PI = 3.14159265358979324 * 3000.0 / 180.0;
      // let PI = 3.1415926535897932384626;
      // let a = 6378245.0;
      // let ee = 0.00669342162296594323;
      let z = Math.sqrt(lng * lng + lat * lat) + 0.00002 * Math.sin(lat * x_PI);
      let theta = Math.atan2(lat, lng) + 0.000003 * Math.cos(lng * x_PI);
      let bd_lng = z * Math.cos(theta) + 0.0065;
      let bd_lat = z * Math.sin(theta) + 0.006;
      return [bd_lng, bd_lat]
    },
    
    transformlat(lng, lat) {
      // let x_PI = 3.14159265358979324 * 3000.0 / 180.0;
      let PI = 3.1415926535897932384626;
      // let a = 6378245.0;
      // let ee = 0.00669342162296594323;
      let ret = -100.0 + 2.0 * lng + 3.0 * lat + 0.2 * lat * lat + 0.1 * lng * lat + 0.2 * Math.sqrt(Math.abs(lng));
      ret += (20.0 * Math.sin(6.0 * lng * PI) + 20.0 * Math.sin(2.0 * lng * PI)) * 2.0 / 3.0;
      ret += (20.0 * Math.sin(lat * PI) + 40.0 * Math.sin(lat / 3.0 * PI)) * 2.0 / 3.0;
      ret += (160.0 * Math.sin(lat / 12.0 * PI) + 320 * Math.sin(lat * PI / 30.0)) * 2.0 / 3.0;
      return ret
    },
  
    transformlng(lng, lat) {
      // let x_PI = 3.14159265358979324 * 3000.0 / 180.0;
      let PI = 3.1415926535897932384626;
      // let a = 6378245.0;
      // let ee = 0.00669342162296594323;
      let ret = 300.0 + lng + 2.0 * lat + 0.1 * lng * lng + 0.1 * lng * lat + 0.1 * Math.sqrt(Math.abs(lng));
      ret += (20.0 * Math.sin(6.0 * lng * PI) + 20.0 * Math.sin(2.0 * lng * PI)) * 2.0 / 3.0;
      ret += (20.0 * Math.sin(lng * PI) + 40.0 * Math.sin(lng / 3.0 * PI)) * 2.0 / 3.0;
      ret += (150.0 * Math.sin(lng / 12.0 * PI) + 300.0 * Math.sin(lng / 30.0 * PI)) * 2.0 / 3.0;
      return ret
    },
  
    /**
     * 判断是否在国内，不在国内则不做偏移
     * @param lng
     * @param lat
     * @returns {boolean}
     */
    out_of_china(lng, lat) {
      return (lng < 72.004 || lng > 137.8347) || ((lat < 0.8293 || lat > 55.8271) || false);
    },
    
  }
};
</script>
